
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>src.component package &#8212; BRMS Engine 1.0 documentation</title>
    
    <link rel="stylesheet" href="_static/alabaster.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    './',
        VERSION:     '1.0',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true,
        SOURCELINK_SUFFIX: '.txt'
      };
    </script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
   
  <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head>
  <body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="src-component-package">
<h1>src.component package<a class="headerlink" href="#src-component-package" title="Permalink to this headline">¶</a></h1>
<div class="section" id="submodules">
<h2>Submodules<a class="headerlink" href="#submodules" title="Permalink to this headline">¶</a></h2>
</div>
<div class="section" id="module-src.component.aggregate">
<span id="src-component-aggregate-module"></span><h2>src.component.aggregate module<a class="headerlink" href="#module-src.component.aggregate" title="Permalink to this headline">¶</a></h2>
<dl class="class">
<dt id="src.component.aggregate.Aggregate">
<em class="property">class </em><code class="descclassname">src.component.aggregate.</code><code class="descname">Aggregate</code><span class="sig-paren">(</span><em>scenario_rule_instance</em>, <em>metadata: src.entity.metadata.MetaData</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/component/aggregate.html#Aggregate"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.aggregate.Aggregate" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <a class="reference internal" href="src.entity.html#src.entity.component.Component" title="src.entity.component.Component"><code class="xref py py-class docutils literal"><span class="pre">src.entity.component.Component</span></code></a></p>
<p>Aggregate component implementation.</p>
<p>This component takes scenarioRuleInstanceId and a copy of MetaData class. MetaData copy is retained
to avoid calls to Salesforce and S3.</p>
<dl class="docutils">
<dt>Methods:</dt>
<dd><p class="first">is_valid(): Currently returns True</p>
<p>is_prepared(): Currently returns True</p>
<p>execute_business_rule(): Override abstract method and uses metadata class to get br_expression
to execute query</p>
<p>make_query(): get input table and br_expression and return the query as string</p>
<p class="last">cleanup_scenario_rule_instance(): Currently function is passed as nothing to be dropped</p>
</dd>
</dl>
<dl class="method">
<dt id="src.component.aggregate.Aggregate.cleanup_scenario_rule_instance">
<code class="descname">cleanup_scenario_rule_instance</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/component/aggregate.html#Aggregate.cleanup_scenario_rule_instance"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.aggregate.Aggregate.cleanup_scenario_rule_instance" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="src.component.aggregate.Aggregate.execute_business_rule">
<code class="descname">execute_business_rule</code><span class="sig-paren">(</span><em>index</em>, <em>rule</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/component/aggregate.html#Aggregate.execute_business_rule"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.aggregate.Aggregate.execute_business_rule" title="Permalink to this definition">¶</a></dt>
<dd><p>For each business rule create BR expression and execute unload query.</p>
</dd></dl>

<dl class="method">
<dt id="src.component.aggregate.Aggregate.is_prepared">
<code class="descname">is_prepared</code><span class="sig-paren">(</span><span class="sig-paren">)</span> &#x2192; bool<a class="reference internal" href="_modules/src/component/aggregate.html#Aggregate.is_prepared"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.aggregate.Aggregate.is_prepared" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="src.component.aggregate.Aggregate.is_valid">
<code class="descname">is_valid</code><span class="sig-paren">(</span><span class="sig-paren">)</span> &#x2192; bool<a class="reference internal" href="_modules/src/component/aggregate.html#Aggregate.is_valid"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.aggregate.Aggregate.is_valid" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="src.component.aggregate.Aggregate.make_query">
<code class="descname">make_query</code><span class="sig-paren">(</span><em>br_expression</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/component/aggregate.html#Aggregate.make_query"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.aggregate.Aggregate.make_query" title="Permalink to this definition">¶</a></dt>
<dd><p>Use metadata to fetch BR expression based on rule Id and return select query.</p>
</dd></dl>

</dd></dl>

</div>
<div class="section" id="module-src.component.datasource">
<span id="src-component-datasource-module"></span><h2>src.component.datasource module<a class="headerlink" href="#module-src.component.datasource" title="Permalink to this headline">¶</a></h2>
<dl class="class">
<dt id="src.component.datasource.DataSource">
<em class="property">class </em><code class="descclassname">src.component.datasource.</code><code class="descname">DataSource</code><span class="sig-paren">(</span><em>scenario_rule_instance</em>, <em>metadata: src.entity.metadata.MetaData</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/component/datasource.html#DataSource"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.datasource.DataSource" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <a class="reference internal" href="src.entity.html#src.entity.component.Component" title="src.entity.component.Component"><code class="xref py py-class docutils literal"><span class="pre">src.entity.component.Component</span></code></a></p>
<p>Execution of the Data Source Component</p>
<p>Create external table in Redshift if the input is external else do nothing</p>
<dl class="docutils">
<dt>Methods (Override from parent class):</dt>
<dd><p class="first">__init__(): Added attribute table_is_external for given scenario rule instance.</p>
<p>is_prepared(): Create external table if input table type is external.</p>
<p>execute_scenario_rule_instance(): Instead of looping through the Business Rules, copy the data from external
table (input) to internal table (output).</p>
<p class="last">cleanup_scenario_rule_instance(): In case of external table (input), call the parent method.</p>
</dd>
</dl>
<dl class="method">
<dt id="src.component.datasource.DataSource.cleanup_scenario_rule_instance">
<code class="descname">cleanup_scenario_rule_instance</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/component/datasource.html#DataSource.cleanup_scenario_rule_instance"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.datasource.DataSource.cleanup_scenario_rule_instance" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="src.component.datasource.DataSource.execute_business_rule">
<code class="descname">execute_business_rule</code><span class="sig-paren">(</span><em>index</em>, <em>rule</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/component/datasource.html#DataSource.execute_business_rule"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.datasource.DataSource.execute_business_rule" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="src.component.datasource.DataSource.execute_scenario_rule_instance">
<code class="descname">execute_scenario_rule_instance</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/component/datasource.html#DataSource.execute_scenario_rule_instance"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.datasource.DataSource.execute_scenario_rule_instance" title="Permalink to this definition">¶</a></dt>
<dd><p>Copies ‘input’ external table to ‘output’ internal table</p>
</dd></dl>

<dl class="method">
<dt id="src.component.datasource.DataSource.is_prepared">
<code class="descname">is_prepared</code><span class="sig-paren">(</span><span class="sig-paren">)</span> &#x2192; bool<a class="reference internal" href="_modules/src/component/datasource.html#DataSource.is_prepared"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.datasource.DataSource.is_prepared" title="Permalink to this definition">¶</a></dt>
<dd><p>Create external table from S3
:return: True if the method runs successfully without any error</p>
</dd></dl>

<dl class="method">
<dt id="src.component.datasource.DataSource.is_valid">
<code class="descname">is_valid</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/component/datasource.html#DataSource.is_valid"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.datasource.DataSource.is_valid" title="Permalink to this definition">¶</a></dt>
<dd><p>Checks if the input file is present in S3 location
:return: True if the file exists in S3 else False</p>
</dd></dl>

<dl class="method">
<dt id="src.component.datasource.DataSource.make_query">
<code class="descname">make_query</code><span class="sig-paren">(</span><em>br_expression</em><span class="sig-paren">)</span> &#x2192; str<a class="reference internal" href="_modules/src/component/datasource.html#DataSource.make_query"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.datasource.DataSource.make_query" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</dd></dl>

</div>
<div class="section" id="module-src.component.derivedfield">
<span id="src-component-derivedfield-module"></span><h2>src.component.derivedfield module<a class="headerlink" href="#module-src.component.derivedfield" title="Permalink to this headline">¶</a></h2>
<dl class="class">
<dt id="src.component.derivedfield.DerivedField">
<em class="property">class </em><code class="descclassname">src.component.derivedfield.</code><code class="descname">DerivedField</code><span class="sig-paren">(</span><em>scenario_rule_instance</em>, <em>metadata: src.entity.metadata.MetaData</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/component/derivedfield.html#DerivedField"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.derivedfield.DerivedField" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <a class="reference internal" href="src.entity.html#src.entity.component.Component" title="src.entity.component.Component"><code class="xref py py-class docutils literal"><span class="pre">src.entity.component.Component</span></code></a></p>
<p>Derived Field implementation.</p>
<p>Adds a column based on rules derived from existing columns, eg. c = a+b</p>
<dl class="method">
<dt id="src.component.derivedfield.DerivedField.cleanup_scenario_rule_instance">
<code class="descname">cleanup_scenario_rule_instance</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/component/derivedfield.html#DerivedField.cleanup_scenario_rule_instance"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.derivedfield.DerivedField.cleanup_scenario_rule_instance" title="Permalink to this definition">¶</a></dt>
<dd><p>Copies the last table created (suffix based) to the original table
and drops intermediate tables created for adding each derived field</p>
</dd></dl>

<dl class="method">
<dt id="src.component.derivedfield.DerivedField.execute_business_rule">
<code class="descname">execute_business_rule</code><span class="sig-paren">(</span><em>index</em>, <em>rule</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/component/derivedfield.html#DerivedField.execute_business_rule"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.derivedfield.DerivedField.execute_business_rule" title="Permalink to this definition">¶</a></dt>
<dd><p>Executes the business rule - adds the corresponding derived field.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first simple">
<li><strong>index</strong> – index of the business rule to be executed for a given scenario rule instance</li>
<li><strong>rule</strong> – record for the business rule to be executed</li>
</ul>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first last"></p>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="src.component.derivedfield.DerivedField.is_prepared">
<code class="descname">is_prepared</code><span class="sig-paren">(</span><span class="sig-paren">)</span> &#x2192; bool<a class="reference internal" href="_modules/src/component/derivedfield.html#DerivedField.is_prepared"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.derivedfield.DerivedField.is_prepared" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="src.component.derivedfield.DerivedField.is_valid">
<code class="descname">is_valid</code><span class="sig-paren">(</span><span class="sig-paren">)</span> &#x2192; bool<a class="reference internal" href="_modules/src/component/derivedfield.html#DerivedField.is_valid"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.derivedfield.DerivedField.is_valid" title="Permalink to this definition">¶</a></dt>
<dd><p>Validates if the output of previous execution is present or not.</p>
</dd></dl>

<dl class="method">
<dt id="src.component.derivedfield.DerivedField.make_query">
<code class="descname">make_query</code><span class="sig-paren">(</span><em>br_expression</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/component/derivedfield.html#DerivedField.make_query"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.derivedfield.DerivedField.make_query" title="Permalink to this definition">¶</a></dt>
<dd><p>Generates the query to be executed in redshift for adding the derived field.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><strong>br_expression</strong> – record for the business rule expression for a business rule</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body">the generated query</td>
</tr>
</tbody>
</table>
</dd></dl>

</dd></dl>

</div>
<div class="section" id="module-src.component.filter">
<span id="src-component-filter-module"></span><h2>src.component.filter module<a class="headerlink" href="#module-src.component.filter" title="Permalink to this headline">¶</a></h2>
<dl class="class">
<dt id="src.component.filter.Filter">
<em class="property">class </em><code class="descclassname">src.component.filter.</code><code class="descname">Filter</code><span class="sig-paren">(</span><em>scenario_rule_instance</em>, <em>metadata: src.entity.metadata.MetaData</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/component/filter.html#Filter"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.filter.Filter" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <a class="reference internal" href="src.entity.html#src.entity.component.Component" title="src.entity.component.Component"><code class="xref py py-class docutils literal"><span class="pre">src.entity.component.Component</span></code></a></p>
<p>Filter component implementation.</p>
<p>This component takes scenarioRuleInstanceId and a copy of MetaData class. MetaData copy is retained
to avoid calls to Salesforce and S3.</p>
<dl class="docutils">
<dt>Methods:</dt>
<dd><p class="first">is_valid():</p>
<p>is_prepared():</p>
<p>execute_business_rule():</p>
<p>make_query():</p>
<p class="last">clean_up_scenario_rule_instance():</p>
</dd>
<dt>Attributes:</dt>
<dd>scenario_rule_instance_id: A component is defined by scenario rule instance Id.
metadata: A component receives a copy of metadata</dd>
</dl>
<dl class="method">
<dt id="src.component.filter.Filter.cleanup_scenario_rule_instance">
<code class="descname">cleanup_scenario_rule_instance</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/component/filter.html#Filter.cleanup_scenario_rule_instance"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.filter.Filter.cleanup_scenario_rule_instance" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="src.component.filter.Filter.execute_business_rule">
<code class="descname">execute_business_rule</code><span class="sig-paren">(</span><em>index</em>, <em>rule</em><span class="sig-paren">)</span> &#x2192; bool<a class="reference internal" href="_modules/src/component/filter.html#Filter.execute_business_rule"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.filter.Filter.execute_business_rule" title="Permalink to this definition">¶</a></dt>
<dd><p>For each business rule create BR expression and execute unload query.</p>
</dd></dl>

<dl class="method">
<dt id="src.component.filter.Filter.is_prepared">
<code class="descname">is_prepared</code><span class="sig-paren">(</span><span class="sig-paren">)</span> &#x2192; bool<a class="reference internal" href="_modules/src/component/filter.html#Filter.is_prepared"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.filter.Filter.is_prepared" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="src.component.filter.Filter.is_valid">
<code class="descname">is_valid</code><span class="sig-paren">(</span><span class="sig-paren">)</span> &#x2192; bool<a class="reference internal" href="_modules/src/component/filter.html#Filter.is_valid"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.filter.Filter.is_valid" title="Permalink to this definition">¶</a></dt>
<dd><p>Validates output of previous execution is present or not.</p>
</dd></dl>

<dl class="method">
<dt id="src.component.filter.Filter.make_query">
<code class="descname">make_query</code><span class="sig-paren">(</span><em>br_expression</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/component/filter.html#Filter.make_query"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.filter.Filter.make_query" title="Permalink to this definition">¶</a></dt>
<dd><p>Use metadata to fetch BR expression based on rule Id and return select query.</p>
</dd></dl>

</dd></dl>

</div>
<div class="section" id="module-src.component.join">
<span id="src-component-join-module"></span><h2>src.component.join module<a class="headerlink" href="#module-src.component.join" title="Permalink to this headline">¶</a></h2>
<dl class="class">
<dt id="src.component.join.Join">
<em class="property">class </em><code class="descclassname">src.component.join.</code><code class="descname">Join</code><span class="sig-paren">(</span><em>scenario_rule_instance</em>, <em>metadata: src.entity.metadata.MetaData</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/component/join.html#Join"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.join.Join" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <a class="reference internal" href="src.entity.html#src.entity.component.Component" title="src.entity.component.Component"><code class="xref py py-class docutils literal"><span class="pre">src.entity.component.Component</span></code></a></p>
<p>Join component implementation inherits Component class.</p>
<p>Tables to be joined can have different schemas.</p>
<dl class="method">
<dt id="src.component.join.Join.cleanup_scenario_rule_instance">
<code class="descname">cleanup_scenario_rule_instance</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/component/join.html#Join.cleanup_scenario_rule_instance"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.join.Join.cleanup_scenario_rule_instance" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="src.component.join.Join.execute_business_rule">
<code class="descname">execute_business_rule</code><span class="sig-paren">(</span><em>index</em>, <em>rule</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/component/join.html#Join.execute_business_rule"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.join.Join.execute_business_rule" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="src.component.join.Join.is_prepared">
<code class="descname">is_prepared</code><span class="sig-paren">(</span><span class="sig-paren">)</span> &#x2192; bool<a class="reference internal" href="_modules/src/component/join.html#Join.is_prepared"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.join.Join.is_prepared" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="src.component.join.Join.is_valid">
<code class="descname">is_valid</code><span class="sig-paren">(</span><span class="sig-paren">)</span> &#x2192; bool<a class="reference internal" href="_modules/src/component/join.html#Join.is_valid"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.join.Join.is_valid" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="src.component.join.Join.make_query">
<code class="descname">make_query</code><span class="sig-paren">(</span><em>br_expression</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/component/join.html#Join.make_query"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.component.join.Join.make_query" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</dd></dl>

</div>
<div class="section" id="module-src.component">
<span id="module-contents"></span><h2>Module contents<a class="headerlink" href="#module-src.component" title="Permalink to this headline">¶</a></h2>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="index.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">src.component package</a><ul>
<li><a class="reference internal" href="#submodules">Submodules</a></li>
<li><a class="reference internal" href="#module-src.component.aggregate">src.component.aggregate module</a></li>
<li><a class="reference internal" href="#module-src.component.datasource">src.component.datasource module</a></li>
<li><a class="reference internal" href="#module-src.component.derivedfield">src.component.derivedfield module</a></li>
<li><a class="reference internal" href="#module-src.component.filter">src.component.filter module</a></li>
<li><a class="reference internal" href="#module-src.component.join">src.component.join module</a></li>
<li><a class="reference internal" href="#module-src.component">Module contents</a></li>
</ul>
</li>
</ul>
<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="index.html">Documentation overview</a><ul>
  </ul></li>
</ul>
</div>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="_sources/src.component.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="search.html" method="get">
      <div><input type="text" name="q" /></div>
      <div><input type="submit" value="Go" /></div>
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2018, SalesIQ-BRM-DM.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 1.6.2</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.10</a>
      
      |
      <a href="_sources/src.component.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>